//+------------------------------------------------------------------+
//|                                   NeutralPrice OscillatorRSI.mq4 |
//|                                             2008.07.27 SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.07.27 SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 1
#property indicator_color1 DeepPink

//-- levels
#property indicator_level1 0
#property indicator_level2 30
#property indicator_level3 50
#property indicator_level4 70
#property indicator_minimum 0
#property indicator_maximum 100

//---- inputs --------------------------------------------------------
extern string Pair1 = "GBPUSD";
extern string Pair2 = "EURUSD";
extern int maxBars = 500;
extern int Period_Differences = 34;
extern int RSI_Period = 14;
//--------------------------------------------------------------------

double Difference[], MeanDifferences[];
double OscLine[];
double RSILine[];

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int init()
{
   ArraySetAsSeries(Difference, true);
   ArraySetAsSeries(MeanDifferences, true);
   ArraySetAsSeries(OscLine, true);

   SetIndexBuffer(0,RSILine); SetIndexLabel(0,"RSI Oscillator"); SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
  
   string sCurrency = AccountCurrency();
   
   string st = "RSI NeutralPrice Oscillator ("+Pair1+"--"+Pair2+ ", " + Period_Differences + ", " + RSI_Period;
   st = st + ") ";
   
   IndicatorShortName(st);
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int deinit()
{
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int start() 
{  
   ArrayResize(Difference, Bars);
   ArrayResize(MeanDifferences, Bars);
   ArrayResize(OscLine, Bars);

   int counted_bars = IndicatorCounted();
   int i, limit;
   double dClose1, dClose2;

   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
   //limit=Bars - counted_bars;
   limit=maxBars;   
   
   for (i=0; i<limit + Period_Differences + RSI_Period + 5; i++)
   {    
      dClose1 = iClose(Pair1, Period(), i);
      dClose2 = iClose(Pair2, Period(), i);
      
      if (dClose2 != 0)
         Difference[i] = dClose1 / dClose2 ;
   }
   
   for (i=0; i<limit + Period_Differences + RSI_Period + 5; i++)
   {  
      MeanDifferences[i] = iMAOnArray(Difference,0, Period_Differences, 0, MODE_SMA, i);
   }   
   
   for (i=0; i<limit + Period_Differences + RSI_Period + 5; i++)
   {  
      double DevRange = iStdDevOnArray(Difference,0, Period_Differences, 0, MODE_SMA, i);
      
      if (DevRange != 0)
         OscLine[i] = (Difference[i] - MeanDifferences[i]) / DevRange;
   }      
   
   for (i=0; i<limit + Period_Differences + RSI_Period + 5; i++)
   {  
      RSILine[i] = iRSIOnArray(OscLine, 0, RSI_Period, i);
   }  
   return(0);
}