//+------------------------------------------------------------------+
//|                                   NeutralPrice Oscillator_v2.mq4 |
//|                                             2008.08.25 SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008.08.25 SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 MediumTurquoise
#property indicator_color3 Tomato
#property indicator_color4 SpringGreen

//-- levels
#property indicator_level1 0
#property indicator_level2 1
#property indicator_level3 2
#property indicator_level4 3
#property indicator_level5 -1
#property indicator_level6 -2
#property indicator_level7 -3
#property indicator_levelcolor Silver

#property indicator_minimum -5
#property indicator_maximum  5

//---- inputs --------------------------------------------------------
extern string Pair1 = "EURUSD";
extern string Pair2 = "USDCHF";
extern int maxBars = 500;
extern int Period_Differences = 34;
extern double BB_Period = 20;
extern double BB_Deviation = 2.0;
//--------------------------------------------------------------------

double Difference[], MeanDifferences[];
double OscLine[];
double MeanLine[], LineUp[], LineDn[];

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int init()
{
   ArraySetAsSeries(Difference, true);
   ArraySetAsSeries(MeanDifferences, true);

   SetIndexBuffer(0,OscLine); SetIndexLabel(0,"PriceOscillator"); SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   //SetIndexBuffer(0,OscLine); SetIndexLabel(0,"PriceOscillator"); SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   
   SetIndexBuffer(1,MeanLine); SetIndexLabel(1,"MeanLine"); SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,LineUp); SetIndexLabel(2,"Short Line"); SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,LineDn); SetIndexLabel(3,"Long Line"); SetIndexStyle(3,DRAW_LINE);
   
   string sCurrency = AccountCurrency();
   
   string st = "NeutralPrice Oscillator_v2 ("+Pair1+"--"+Pair2+ ", " + Period_Differences;
   st = st + ") ";
   
   IndicatorShortName(st);
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int deinit()
{
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int start() 
{  
   ArrayResize(Difference, Bars);
   ArrayResize(MeanDifferences, Bars);

   int counted_bars = IndicatorCounted();
   int i, limit;
   double dClose1, dClose2;

   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
   //limit=Bars - counted_bars;
   limit=maxBars;   
   
   for (i=0; i<limit + Period_Differences + BB_Period + 5; i++)
   {    
      datetime dDateTime1 = iTime(Pair1, Period(), i);
      int iBar2 = iBarShift(Pair2, Period(), dDateTime1);
      
      dClose1 = iClose(Pair1, Period(), i);
      dClose2 = iClose(Pair2, Period(), iBar2);
      
      if (dClose2 != 0)
         Difference[i] = dClose1 / dClose2 ;
   }
   
   for (i=0; i<limit + Period_Differences + BB_Period + 5; i++)
   {  
      MeanDifferences[i] = iMAOnArray(Difference,0, Period_Differences, 0, MODE_SMA, i);
   }   
   
   for (i=0; i<limit + Period_Differences + BB_Period + 5; i++)
   {  
      double DevRange = iStdDevOnArray(Difference,0, Period_Differences, 0, MODE_SMA, i);
      
      if (DevRange != 0)
         OscLine[i] = (Difference[i] - MeanDifferences[i]) / DevRange;
   }      
   
   for (i=0; i<limit + Period_Differences + BB_Period + 5; i++)
   {  
      MeanLine[i] = iBandsOnArray(OscLine, 0, BB_Period, BB_Deviation, 0, MODE_MAIN, i);     
      
      LineUp[i] = iBandsOnArray(OscLine, 0, BB_Period, BB_Deviation, 0, MODE_UPPER, i);
      LineDn[i] = iBandsOnArray(OscLine, 0, BB_Period, BB_Deviation, 0, MODE_LOWER, i);
   }  
   return(0);
}